apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  labels:
    {{ network_policy_deployment_label }}: job-{{ tekton_name }}
    version: "{{ tekton_assets_version }}"
  name: sign-image-gpg
  namespace: {{ buildns }}
spec:
  params:
{% if k8s_flavor != 'openshift' %}
  - default: ""
    name: dockeruser
    type: string
  - default: ""
    name: dockersecret
    type: string
{% endif %}
  - name: dstimage
    description: Image to Sign
    type: string
  - name: IMAGE_DIGEST
    description: Reference of the Image we want to Sign
    type: string
    default: latest
  - default: "true"
    description: Verify the TLS on the registry endpoint (for push/pull to a non-TLS registry)
    name: tlsverify
    type: string
  steps:
  - args:
    - -c
    - |
        echo "==== Signing $(params.dstimage) ===="
        IMAGE_ROOT=`echo $(params.dstimage) | sed 's|:[^:]*$||'`
        if echo "$(params.IMAGE_DIGEST)" | grep ^sha >/dev/null; then
            IMGADDR="$IMAGE_ROOT@$(params.IMAGE_DIGEST)"
        else
            IMGADDR="$IMAGE_ROOT:$(params.IMAGE_DIGEST)"
        fi
        echo "=> Resolved to $IMGADDR"
        if ! test -s /secret/private.asc; then
            echo "Did not find GPG private key - $IMGADDR will not be signed"
            exit 0
        fi
        if ! gpg --import /secret/private.asc; then
            echo Failed importing GPG Signing Key
            exit 1
        fi
        KEY_ID=`gpg --list-keys | awk '/@/{print $NF;exit 0}' | sed 's|[<>]||g'`
        if test -z "$KEY_ID"; then
            echo Failed resolving GPG Key Id
            exit 1
        fi
        REGISTRY_HOST=$(echo $(params.dstimage) | cut -d/ -f1)
        REGPROTO=http
        if test "$(params.tlsverify)" = true; then
            REGPROTO=https
        fi
        (
            echo "docker:"
            echo "  sigstore: $REGPROTO://$REGISTRY_HOST"
            echo "  sigstore-staging: file:///var/lib/containers/sigstore"
        ) >/etc/containers/registries.d/default.yaml
{% if k8s_flavor == 'openshift' %}
        USERNAME={{ pipeline_sa }}
        PASSWORD="$(cat /var/run/secrets/kubernetes.io/serviceaccount/token)"
{% else %}
        PASSWORD=$(params.dockersecret)
        USERNAME=$(params.dockeruser)
{% endif %}
        if test "$USERNAME" -a "$PASSWORD"; then
            if test "$(params.tlsverify)" = true; then
                if ! podman login -u $USERNAME -p $PASSWORD $REGISTRY_HOST; then
                    echo "Failed logging into registry $REGISTRY_HOST"
                    exit 1
                fi
            elif ! podman login --tls-verify=false -u $USERNAME -p $PASSWORD $REGISTRY_HOST; then
                echo "Failed logging into insecure registry $REGISTRY_HOST"
                exit 1
            fi
        fi
        if ! podman pull docker://$IMGADDR --tls-verify=$(params.tlsverify); then
            echo "Failed pulling $IMGADDR"
            exit 1
        elif ! podman push --sign-by $KEY_ID docker://$IMGADDR --tls=verify=$(params.tlsverify); then
            echo "Failed Signing $IMGADDR"
            exit 1
        else
            echo "Successfully signed $IMGADDR"
        fi
        exit 0
    command:
    - /bin/sh
    image: {{ (opsimages | json_query("[?name=='jkagsign'].image"))[0] }}
    name: sign-image
{% if tekton_uses_resources_limits | default(False) %}
    resources:
      limits:
        cpu: "{{ tekton_sign_cpu_limit }}"
        memory: {{ tekton_sign_memory_limit }}
      requests:
        cpu: "{{ tekton_sign_cpu_request }}"
        memory: {{ tekton_sign_memory_request }}
{% else %}
    resources: {}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
    securityContext:
      privileged: true
{% endif %}
  workspaces:
  - name: sigsecret
    mountPath: /secret
    optional: true
